Weblate’s REST API

The API is accessible on the /api/ URL and it is based on Django REST framework. You can use it directly or by Weblate Client. See Libraries and SDKs for official tools and community-maintained integrations.

The API is also documented using OpenAPI 3.1 on the /api/schema/ URL, you can browse at /api/docs/.

Authentication and generic parameters

The read-only API is available without authentication unless REQUIRE_LOGIN is turned on. Unauthenticated requests are heavily throttled (by default to 100 requests per day), so it is recommended to use authentication.

The authentication uses a token, which you can get in your profile. Use it in the Authorization header with the Token or Bearer scheme. Unsupported schemes, such as Basic, return 401 Unauthorized, even for public endpoints or when you are signed in using a browser session.

ANY /

Generic request behaviour for the API, the headers, status codes and parameters here apply to all endpoints as well.

Query Parameters:
  • format – Response format (overrides Accept). Possible values depend on REST framework setup, by default json, csv and api are supported. The latter provides a web browser interface for the API.

  • page – Returns given page of paginated results (use next and previous fields in response to automate the navigation).

  • page_size – Return the given number of items per request. The default is 50 and the maximum is 1000. For the units endpoints the default is 100 with a maximum of 10000. The default value is also configurable using the PAGE_SIZE setting.

Request Headers:
  • Accept – the response content type depends on Accept header

  • Authorization – optional token to authenticate as Authorization: Token YOUR-TOKEN

Response Headers:
Request JSON Object:
  • detail (string) – verbose description of the result (for HTTP status codes other than 200 OK)

  • count (int) – total item count for object lists

  • next (string) – next page URL for object lists

  • previous (string) – previous page URL for object lists

  • results (array) – results for object lists

  • url (string) – URL to access this resource using the API

  • web_url (string) – URL to access this resource using web browser

Status Codes:

Authentication tokens

Changed in version 4.10: Project scoped tokens were introduced in the 4.10 release.

Each user has a personal access token which can be obtained in the user profile. Newly generated user tokens have the wlu_ prefix.

It is possible to create project scoped tokens for API access to given project only. These tokens can be identified by the wlp_ prefix.

Authentication examples

Example request:

GET /api/ HTTP/1.1
Host: example.com
Accept: application/json, text/javascript
Authorization: Token YOUR-TOKEN

Example response:

HTTP/1.0 200 OK
Date: Fri, 25 Mar 2016 09:46:12 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, HEAD, OPTIONS

{
    "projects":"http://example.com/api/projects/",
    "components":"http://example.com/api/components/",
    "translations":"http://example.com/api/translations/",
    "languages":"http://example.com/api/languages/"
}

CURL example:

curl \
    -H "Authorization: Token TOKEN" \
    https://example.com/api/

Passing Parameters Examples

For the POST method the parameters can be specified either as form submission (application/x-www-form-urlencoded) or as JSON (application/json).

Form request example:

POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/x-www-form-urlencoded
Authorization: Token TOKEN

operation=pull

JSON request example:

POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{"operation":"pull"}

CURL example:

curl \
    -d operation=pull \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/components/hello/weblate/repository/

CURL JSON example:

curl \
    --data-binary '{"operation":"pull"}' \
    -H "Content-Type: application/json" \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/components/hello/weblate/repository/

Components and categories

To access a component which is nested inside a Category, you need to URL encode the category name into a component name separated with a slash. For example usage placed in a docs category needs to be used as docs%252Fusage. Full URL in this case would be for example https://example.com/api/components/hello/docs%252Fusage/repository/.

API rate limiting

The API requests are rate limited; the default configuration limits it to 100 requests per day for anonymous users and 5000 requests per hour for authenticated users.

Configure the default limits in settings.py using API_RATELIMIT_ANON and API_RATELIMIT_USER.

In the Docker container this can be configured using WEBLATE_API_RATELIMIT_ANON and WEBLATE_API_RATELIMIT_USER.

Use API_RATELIMIT_USER_OVERRIDES to give an automation account a different limit. Use API_RATELIMIT_IP_OVERRIDES for individual IP addresses or networks, including anonymous CI clients:

API_RATELIMIT_USER_OVERRIDES = {"automation": "20000/hour"}
API_RATELIMIT_IP_OVERRIDES = {
    "192.0.2.42": None,
    "198.51.100.0/24": "10000/hour",
    "2001:db8::/48": "10000/hour",
}

An explicit username override takes precedence over IP rules. Otherwise, the most specific matching network applies; an individual address is equivalent to a single-address network. A value of None exempts matching requests from API rate limits, including the anonymous limit. Authentication and permissions still apply: an exemption does not grant access to private projects or write operations.

Limits are counted per authenticated user, or per client IP for anonymous requests. Clients within a network do not share a single budget. Each override rule and rate has a separate budget, so changing a rule or rate starts a new budget. Requests without an override use the default limits.

IP rules use the client address resolved by Weblate. Behind a reverse proxy, configure IP_BEHIND_REVERSE_PROXY, IP_PROXY_HEADER, and IP_PROXY_OFFSET correctly. The trusted proxy must supply the client address, and untrusted clients must not be able to bypass it. Exempting a shared proxy address can exempt all clients using that proxy.

In Docker, configure the equivalent JSON mappings using WEBLATE_API_RATELIMIT_USER_OVERRIDES and WEBLATE_API_RATELIMIT_IP_OVERRIDES. Use JSON null for exemptions.

The status of rate limiting is reported in following headers:

X-RateLimit-Limit

Allowed number of requests to perform

X-RateLimit-Remaining

Remaining number of requests to perform

X-RateLimit-Reset

Number of seconds until the rate-limit window resets

Requests exempt from rate limiting do not include these headers.

Changed in version 4.1: Added ratelimiting status headers.

Error responses

Changed in version 5.10: Error responses were endpoint specific before this release.

Weblate error responses are formatted based on Error Response Format.

API Entry Point

GET /api/

The API root entry point.

Example request:

GET /api/ HTTP/1.1
Host: example.com
Accept: application/json, text/javascript
Authorization: Token YOUR-TOKEN

Example response:

HTTP/1.0 200 OK
Date: Fri, 25 Mar 2016 09:46:12 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, HEAD, OPTIONS

{
    "projects":"http://example.com/api/projects/",
    "components":"http://example.com/api/components/",
    "translations":"http://example.com/api/translations/",
    "languages":"http://example.com/api/languages/"
}

Users

Added in version 4.0.

GET /api/users/

Returns no results to unauthenticated users. Authenticated users without the global user.view or user.edit permission see only their own basic details when listing without a username filter. They can search for other users by supplying a username prefix of at least two characters after trimming surrounding whitespace; these searches return the user ID, username, and full name of matching non-bot users. Users with either permission can list all users and receive detailed information.

USER_DIRECTORY_VISIBILITY can restrict discovery to accessible resources. In scoped and disabled modes, ordinary users must supply a resource-bounded q query or an accessible unit context to discover other users. Generic filters cannot expand that scope; blocked searches return no results. Self access and global administrative access remain available. Basic contributor discovery is independent of USER_PROFILE_VISIBILITY.

Query Parameters:
  • q (string) – User search query, such as contributes:project or contributes:project/component. Every matching Boolean branch must have a positive resource scope in restricted directory modes.

  • unit (int) – Rank contributors to this string first. In restricted directory modes, results are limited to contributors to its translation.

  • username (string) – Username prefix to search for. At least two characters after trimming surrounding whitespace are required for users without the global user.view or user.edit permission.

  • id (int) – User ID to search for

  • email (string) – Email to search for (case-insensitive, exact match). Requires user.view or user.edit permission; the parameter is ignored for unprivileged users.

Username searches by users without the global user.view or user.edit permission exclude bot accounts other than the caller’s own account.

See also

Users object attributes are documented at GET /api/users/(str:username)/.

POST /api/users/

Creates a new user.

Requires the global user.edit permission. See Access control for the user management permission model.

Parameters:
  • username (string) – Username

  • full_name (string) – User full name

  • email (string) – User email

  • is_superuser (boolean) – Is user superuser? (optional)

  • is_active (boolean) – Is user active? (optional)

  • is_bot (boolean) – Is user bot? (optional) (used for project scoped tokens)

GET /api/users/(str: username)/

Access follows USER_PROFILE_VISIBILITY. Restricted profiles return HTTP 404; self access and global administrative access are retained.

Returns information about users.

Parameters:
  • username (string) – User’s username

Request JSON Object:
  • username (string) – username of a user

  • full_name (string) – full name of a user

  • email (string) – email of a user

  • is_superuser (boolean) – whether the user is a super user

  • is_active (boolean) – whether the user is active

  • is_bot (boolean) – whether the user is bot (used for project scoped tokens)

  • date_joined (string) – date the user is created

  • last_login (string) – date the user last signed in

  • groups (array) – link to associated groups; see GET /api/groups/(int:id)/

  • profile (object) – user profile preferences; see User profile. Returned only with the user.view or user.edit permission.

Example JSON data:

{
    "email": "user@example.com",
    "full_name": "Example User",
    "username": "exampleusername",
    "groups": [
        "http://example.com/api/groups/2/",
        "http://example.com/api/groups/3/"
    ],
    "profile": {
        "language": "en",
        "languages": [
            "http://example.com/api/languages/cs/"
        ],
        "secondary_languages": [],
        "translated": 42,
        "suggested": 3,
        "uploaded": 1,
        "commented": 5,
        "theme": "auto",
        "hide_completed": false,
        "secondary_in_zen": true,
        "hide_source_secondary": false,
        "wide_tables": false,
        "listing_columns": ["untranslated", "untranslated_words", "untranslated_chars", "nottranslated", "checks", "suggestions", "comments"],
        "editor_link": "",
        "translate_mode": 0,
        "zen_mode": 0,
        "special_chars": "",
        "nearby_strings": 10,
        "auto_watch": true,
        "contribute_personal_tm": true,
        "dashboard_view": 1,
        "dashboard_component_list": null,
        "watched": [],
        "website": "https://example.com/",
        "contact": "",
        "liberapay": "",
        "fediverse": "",
        "codesite": "",
        "github": "",
        "twitter": "",
        "linkedin": "",
        "location": "",
        "company": "",
        "public_email": "",
        "commit_email": "",
        "commit_name": 0,
        "last_2fa": ""
    },
    "is_superuser": true,
    "is_active": true,
    "is_bot": false,
    "date_joined": "2020-03-29T18:42:42.617681Z",
    "url": "http://example.com/api/users/exampleusername/",
    "contributions_url": "http://example.com/api/users/exampleusername/contributions/",
    "statistics_url": "http://example.com/api/users/exampleusername/statistics/"
}
PUT /api/users/(str: username)/

Changes the user parameters.

Requires the global user.edit permission unless a user is updating their own account or profile fields. See Access control for the user management permission model.

Parameters:
  • username (string) – User’s username

Request JSON Object:
  • username (string) – username of a user

  • full_name (string) – full name of a user

  • email (string) – email of a user

  • is_superuser (boolean) – whether the user is a super user

  • is_active (boolean) – whether the user is active

  • is_bot (boolean) – whether the user is bot (used for project scoped tokens)

  • date_joined (string) – date the user is created

  • profile (object) – updated profile preferences when included in the request; see User profile

PATCH /api/users/(str: username)/

Changes the user parameters.

Requires the global user.edit permission unless a user is updating their own account or profile fields. See Access control for the user management permission model.

Parameters:
  • username (string) – User’s username

Request JSON Object:
  • username (string) – username of a user

  • full_name (string) – full name of a user

  • email (string) – email of a user

  • is_superuser (boolean) – whether the user is a super user

  • is_active (boolean) – whether the user is active

  • is_bot (boolean) – whether the user is bot (used for project scoped tokens)

  • date_joined (string) – date the user is created

  • profile (object) – updated profile preferences when included in the request; see User profile

DELETE /api/users/(str: username)/

Deletes all user information and marks the user inactive.

Requires the global user.edit permission. See Access control for the user management permission model.

Parameters:
  • username (string) – User’s username

POST /api/users/(str: username)/groups/

Associate groups with a user.

Requires the global user.edit permission. See Access control for the user management permission model. This permission authorizes membership changes for every team, including project and workspace teams; no separate permission over the target team is required.

Parameters:
  • username (string) – User’s username

Form Parameters:
  • string group_id – The unique group ID

DELETE /api/users/(str: username)/groups/

Added in version 4.13.1.

Remove user from a group.

Requires the global user.edit permission. See Access control for the user management permission model. This permission authorizes membership changes for every team, including project and workspace teams; no separate permission over the target team is required.

Parameters:
  • username (string) – User’s username

Form Parameters:
  • string group_id – The unique group ID

GET /api/users/(str: username)/statistics/

List statistics of a user.

Parameters:
  • username (string) – User’s username

Request JSON Object:
  • translated (int) – Number of translations by user

  • suggested (int) – Number of suggestions by user

  • uploaded (int) – Number of uploads by user

  • commented (int) – Number of comments by user

  • languages (int) – Number of languages user can translate

GET /api/users/(str: username)/contributions/

List translations with contributions from a user.

Parameters:
  • username (string) – User’s username

Request JSON Object:
GET /api/users/(str: username)/notifications/

List subscriptions of a user.

Parameters:
  • username (string) – User’s username

Request JSON Object:
  • project (string) – Link to the project, or null for other scopes

  • component (string) – Link to the component, or null for other scopes

POST /api/users/(str: username)/notifications/

Associate subscriptions with a user.

Parameters:
  • username (string) – User’s username

Response JSON Object:
  • notification (string) – Name of notification registered

  • scope (int) – Scope of notification from the available choices

  • frequency (int) – Frequency choices for notifications

GET /api/users/(str: username)/notifications/(int: subscription_id)/

Get a subscription associated with a user.

Parameters:
  • username (string) – User’s username

  • subscription_id (int) – ID of notification registered

Request JSON Object:
  • project (string) – Link to the project, or null for other scopes

  • component (string) – Link to the component, or null for other scopes

PUT /api/users/(str: username)/notifications/(int: subscription_id)/

Edit a subscription associated with a user.

Parameters:
  • username (string) – User’s username

  • subscription_id (int) – ID of notification registered

Response JSON Object:
  • notification (string) – Name of notification registered

  • scope (int) – Scope of notification from the available choices

  • frequency (int) – Frequency choices for notifications

PATCH /api/users/(str: username)/notifications/(int: subscription_id)/

Edit a subscription associated with a user.

Parameters:
  • username (string) – User’s username

  • subscription_id (int) – ID of notification registered

Response JSON Object:
  • notification (string) – Name of notification registered

  • scope (int) – Scope of notification from the available choices

  • frequency (int) – Frequency choices for notifications

DELETE /api/users/(str: username)/notifications/(int: subscription_id)/

Delete a subscription associated with a user.

Parameters:
  • username (string) – User’s username

  • subscription_id – Name of notification registered

  • subscription_id – int

User profile

Added in version 2026.8.

The user API exposes profile preferences in a nested profile object. The object is returned on GET /api/users/(str:username)/ only for callers with the user.view or user.edit permission. Users without those permissions can still update their own profile through PATCH /api/users/(str:username)/; the response then includes the updated profile object.

Profile fields mirror the settings described in User profile.

Groups

Added in version 4.0.

Changing a site-wide group’s access scope requires the global group.edit permission. This trusted administrative permission is not limited by the caller’s project access: project and component association endpoints can grant team members access to private projects the caller cannot access directly. See Site-wide team management for the permission model and narrower delegation options.

GET /api/groups/

Returns a list of groups if you have permissions to see manage groups. If not, then you get to see only the groups the user is a part of.

See also

Group object attributes are documented at GET /api/groups/(int:id)/.

POST /api/groups/

Creates a new group.

Parameters:
GET /api/groups/(int: id)/

Returns information about the group.

Parameters:
  • id (int) – Group’s ID

Request JSON Object:

Example JSON data:

{
    "name": "Guests",
    "defining_project": null,
    "project_selection": 3,
    "language_selection": 1,
    "url": "http://example.com/api/groups/1/",
    "roles": [
        "http://example.com/api/roles/1/",
        "http://example.com/api/roles/2/"
    ],
    "languages": [
        "http://example.com/api/languages/en/",
        "http://example.com/api/languages/cs/",
    ],
    "projects": [
        "http://example.com/api/projects/demo1/",
        "http://example.com/api/projects/demo/"
    ],
    "componentlist": "http://example.com/api/component-lists/new/",
    "components": [
        "http://example.com/api/components/demo/weblate/"
    ],
    "admins": [
        "http://example.com/api/users/exampleusername/"
    ]
}
PUT /api/groups/(int: id)/

Changes the group parameters.

Parameters:
  • id (int) – Group’s ID

Request JSON Object:
  • name (string) – name of a group

  • project_selection (int) – integer corresponding to group of projects

  • language_selection (int) – integer corresponding to group of languages

PATCH /api/groups/(int: id)/

Changes the group parameters.

Parameters:
  • id (int) – Group’s ID

Request JSON Object:
  • name (string) – name of a group

  • project_selection (int) – integer corresponding to group of projects

  • language_selection (int) – integer corresponding to group of languages

DELETE /api/groups/(int: id)/

Deletes the group.

Parameters:
  • id (int) – Group’s ID

POST /api/groups/(int: id)/roles/

Associate roles with a group.

Parameters:
  • id (int) – Group’s ID

Form Parameters:
  • string role_id – The unique role ID

DELETE /api/groups/(int: id)/roles/(int: role_id)

Delete role from a group.

Parameters:
  • id (int) – Group’s ID

  • role_id (int) – The unique role ID

POST /api/groups/(int: id)/components/

Associate components with a group.

Parameters:
  • id (int) – Group’s ID

Form Parameters:
  • string component_id – The unique component ID

DELETE /api/groups/(int: id)/components/(int: component_id)

Delete component from a group.

Parameters:
  • id (int) – Group’s ID

  • component_id (int) – The unique component ID

POST /api/groups/(int: id)/projects/

Associate projects with a group.

Parameters:
  • id (int) – Group’s ID

Form Parameters:
  • string project_id – The unique project ID

DELETE /api/groups/(int: id)/projects/(int: project_id)

Delete project from a group.

Parameters:
  • id (int) – Group’s ID

  • project_id (int) – The unique project ID

POST /api/groups/(int: id)/languages/

Associate languages with a group.

Parameters:
  • id (int) – Group’s ID

Form Parameters:
  • string language_code – The unique language code

DELETE /api/groups/(int: id)/languages/(string: language_code)

Delete language from a group.

Parameters:
  • id (int) – Group’s ID

  • language_code (string) – The unique language code

POST /api/groups/(int: id)/componentlists/

Associate componentlists with a group.

Parameters:
  • id (int) – Group’s ID

Form Parameters:
  • string component_list_id – The unique componentlist ID

DELETE /api/groups/(int: id)/componentlists/(int: component_list_id)

Delete componentlist from a group.

Parameters:
  • id (int) – Group’s ID

  • component_list_id (int) – The unique componentlist ID

POST /api/groups/(int: id)/admins/

Added in version 5.5.

Add user to team admins.

Parameters:
  • id (int) – Group’s ID

Form Parameters:
  • string user_id – The user’s ID

DELETE /api/groups/(int: id)/admins/(int: user_id)

Added in version 5.5.

Delete user from team admins.

Parameters:
  • id (int) – Group’s ID

  • user_id (integer) – The user’s ID

Roles

GET /api/roles/

Returns a list of all roles associated with user. If user is superuser, then list of all existing roles is returned.

See also

Roles object attributes are documented at GET /api/roles/(int:id)/.

POST /api/roles/

Creates a new role.

Parameters:
  • name (string) – Role name

  • permissions (array) – List of codenames of permissions

GET /api/roles/(int: id)/

Returns information about the role.

Parameters:
  • id (int) – Role’s ID

Request JSON Object:
  • name (string) – Role name

  • permissions (array) – list of codenames of permissions

Example JSON data:

{
    "name": "Access repository",
    "permissions": [
        "vcs.access",
        "vcs.view"
    ],
    "url": "http://example.com/api/roles/1/",
}
PUT /api/roles/(int: id)/

Changes the role parameters.

Parameters:
  • id (int) – Role’s ID

Request JSON Object:
  • name (string) – Role name

  • permissions (array) – list of codenames of permissions

PATCH /api/roles/(int: id)/

Changes the role parameters.

When supplied, permissions replaces the role’s complete permission set. Omit it to keep the existing permissions unchanged, or pass an empty list to remove all permissions.

Parameters:
  • id (int) – Role’s ID

Request JSON Object:
  • name (string) – Role name

  • permissions (array) – list of codenames of permissions

DELETE /api/roles/(int: id)/

Deletes the role.

Parameters:
  • id (int) – Role’s ID

Languages

GET /api/languages/

Returns a list of all languages.

See also

Language object attributes are documented at GET /api/languages/(string:language)/.

POST /api/languages/

Creates a new language.

Parameters:
  • code (string) – Language name

  • name (string) – Language name

  • direction (string) – Text direction

  • population (int) – Number of speakers

  • plural (object) – Language plural formula and number

GET /api/languages/(string: language)/

Returns information about the language.

Parameters:
  • language (string) – Language code

Request JSON Object:
  • code (string) – Language code

  • direction (string) – Text direction

  • plural (object) – Object of language plural information

  • aliases (array) – Array of aliases for language

Response JSON Object:
  • population (int) – Number of speakers

Example JSON data:

{
    "code": "en",
    "direction": "ltr",
    "name": "English",
    "population": 159034349015,
    "plural": {
        "id": 75,
        "source": 0,
        "number": 2,
        "formula": "n != 1",
        "type": 1
    },
    "aliases": [
        "english",
        "en_en",
        "base",
        "source",
        "eng"
    ],
    "url": "http://example.com/api/languages/en/",
    "web_url": "http://example.com/languages/en/",
    "statistics_url": "http://example.com/api/languages/en/statistics/"
}
PUT /api/languages/(string: language)/

Changes the language parameters.

Parameters:
  • language (string) – Language’s code

Response JSON Object:
  • name (string) – Language name

  • direction (string) – Text direction

  • population (int) – Number of speakers

The plural field can only be set when creating a language and is rejected on updates.

PATCH /api/languages/(string: language)/

Changes the language parameters.

Parameters:
  • language (string) – Language’s code

Response JSON Object:
  • name (string) – Language name

  • direction (string) – Text direction

  • population (int) – Number of speakers

The plural field can only be set when creating a language and is rejected on updates.

DELETE /api/languages/(string: language)/

Deletes the language.

Parameters:
  • language (string) – Language’s code

GET /api/languages/(string: language)/statistics/

Returns statistics for a language.

Parameters:
  • language (string) – Language code

See also

Returned attributes are described in Statistics.

Projects

GET /api/projects/

Returns a list of all projects.

See also

Project object attributes are documented at GET /api/projects/(string:project)/.

POST /api/projects/

Creates a new project.

Parameters:

Omit access_control to use the configured default. Explicit non-default access control requires a superuser unless a billing plan determines the value. On Hosted Weblate, Custom access control is unavailable and each translation-memory contribution setting is forced to match its corresponding usage setting.

GET /api/projects/(string: project)/

Returns information about the project.

Parameters:
  • project (string) – Project URL slug

Request JSON Object:

Example JSON data:

{
    "name": "Hello",
    "slug": "hello",
    "url": "http://example.com/api/projects/hello/",
    "web": "https://weblate.org/",
    "web_url": "http://example.com/projects/hello/"
}
GET /api/projects/(string: project)/languages/(string: language)/workflow/

Return project-language workflow settings. When no project override exists, return inherited site-wide workflow settings, or defaults when none exist, without creating an override. Reviews remain disabled when both project review settings are disabled. The language is identified by its code. Access to the project is required.

Request JSON Object:
  • language (string) – Language code (read-only)

  • source_language (string) – Custom source language code, or null for the component source; see Custom source language

  • translation_review (boolean) – Enable translation review

  • enable_suggestions (boolean) – Enable suggestions

  • restrict_direct_editing (boolean) – Require suggestions instead of direct editing

  • suggestion_voting (boolean) – Enable voting on suggestions

  • suggestion_autoaccept (integer) – Number of votes required to accept suggestions, or 0 to disable

PATCH /api/projects/(string: project)/languages/(string: language)/workflow/

Create or update a project-language workflow override. Requires permission to edit the project. Accepts the writable fields returned by GET /api/projects/(string:project)/languages/(string:language)/workflow/. Omitted fields retain their values, including inherited workflow settings when creating an override. Enabling reviews requires source or translation reviews to be enabled on the project. Set source_language to null to use the component source. Source languages must exist in the project and must not form a dependency cycle. Changes reconcile affected units before the request completes.

DELETE /api/projects/(string: project)/languages/(string: language)/workflow/

Remove the project-language workflow override, restoring inherited settings. Requires permission to edit the project. Returns HTTP 204, including when no override exists.

All three methods return HTTP 409 if legacy data contains multiple workflow overrides for the same project and language. Resolve the duplicate settings before using this endpoint; the API does not choose or delete them implicitly.

PATCH /api/projects/(string: project)/

Added in version 4.3.

Edit a project by a PATCH request.

The project value is the project slug. To avoid using a wrong identifier, use the project url returned by GET /api/projects/ or GET /api/projects/(string:project)/.

The request body accepts project fields such as instructions, license, access_control, and translation-memory settings.

Example JSON data:

{
    "instructions": "Translate consistently.",
    "license": "MIT",
    "use_shared_tm": true,
    "access_control": 100
}

Changing access_control or public_sharing requires permission to manage project access. Making a project publicly accessible can require licenses on its components when LICENSE_REQUIRED is enabled. On Hosted Weblate, Custom access control is unavailable and each translation-memory contribution setting is forced to match its corresponding usage setting.

Changing workspace moves the project. Moving a project requires permission to edit the project and the Edit workspace settings permission for the source and target workspace. The target workspace also requires the Add projects to workspace permission. Moving a project out of a workspace also requires the site-wide Add new projects permission. See Project creation and moves.

Parameters:
PUT /api/projects/(string: project)/

Added in version 4.3.

Edit a project by a PUT request.

Changing workspace follows the same permission checks as PATCH /api/projects/(string:project)/.

Parameters:
DELETE /api/projects/(string: project)/

Deletes a project.

Parameters:
  • project (string) – Project URL slug

GET /api/projects/(string: project)/changes/

Returns a list of project changes. This is essentially a project scoped GET /api/changes/ accepting same params.

Parameters:
  • project (string) – Project URL slug

Request JSON Object:
GET /api/projects/(string: project)/file/

Added in version 5.5.

Downloads translations associated with the project as an archive file using the requested format and language. The archive includes only translations for which the user has download permission. Component restrictions and language limits are evaluated for each translation.

Parameters:
  • project (string) – Project URL slug

Query Parameters:
  • format (string) – The archive format to use; If not specified, defaults to zip; Supported formats: zip and zip:CONVERSION where CONVERSION is one of converters listed at Downloading translations.

  • language_code (string) – The language code to download; If not specified, all languages are included.

GET /api/projects/(string: project)/repository/

Returns information about the VCS repository status. This endpoint contains only an overall summary for all repositories for the project. To get more detailed status use GET /api/components/(string:project)/(string:component)/repository/.

Repository status includes repositories where the user has a VCS permission on the component owning that repository. Repositories whose owners do not grant this permission are omitted and reported separately.

Parameters:
  • project (string) – Project URL slug

Request JSON Object:
  • needs_commit (boolean) – whether there are any pending changes to commit

  • needs_merge (boolean) – whether there are any upstream changes to merge

  • needs_push (boolean) – whether there are any local changes to push

  • included_components (array) – full paths of project components included in the status

  • skipped_components (array) – full paths of project components omitted from the status

  • permission_blockers (array) – full paths of components preventing access to omitted repositories

Example JSON data:

{
    "included_components": ["hello/app"],
    "needs_commit": true,
    "needs_merge": false,
    "needs_push": true,
    "permission_blockers": ["shared/glossary"],
    "skipped_components": ["hello/glossary"]
}
POST /api/projects/(string: project)/repository/

Performs given operation on the VCS repository.

Repository operations process repositories where the user has the requested VCS permission on the component owning that repository. Repositories whose owners do not grant this permission are skipped. The request is denied when no repository is eligible for the operation.

Parameters:
  • project (string) – Project URL slug

Response JSON Object:
  • operation (string) – Operation to perform: one of push, pull, commit, reset, cleanup, file-sync, file-scan

  • background (boolean) – Schedule the operation as a background task instead of waiting for it to finish. Defaults to false.

Request JSON Object:
  • result (boolean) – result of a synchronous operation

  • included_components (array) – full paths of project components included in the operation

  • skipped_components (array) – full paths of project components omitted from the operation

  • permission_blockers (array) – full paths of components preventing access to omitted repositories

  • detail (string) – Status of a background operation

  • task_url (string) – URL for tracking a background operation; see GET /api/tasks/(str:uuid)/

With background set to true, the endpoint returns 202 Accepted. Repeating an identical queued operation returns the existing task URL. A conflicting operation returns 423 Locked and the active task URL when available. Eligible project repositories are processed sequentially in one task.

CURL example:

curl \
    -d operation=pull \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/projects/hello/repository/

JSON request example:

POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{"operation":"pull"}

JSON response example:

HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{
    "included_components": ["hello/app"],
    "permission_blockers": ["shared/glossary"],
    "result": true,
    "skipped_components": ["hello/glossary"]
}

Background JSON request example:

POST /api/projects/hello/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN

{"operation":"pull","background":true}

Background JSON response example:

HTTP/1.0 202 Accepted
Content-Type: application/json

{
    "detail": "Repository operation has been queued.",
    "included_components": ["hello/app"],
    "permission_blockers": ["shared/glossary"],
    "skipped_components": ["hello/glossary"],
    "task_url": "https://example.com/api/tasks/01234567-89ab-cdef-0123-456789abcdef/"
}
GET /api/projects/(string: project)/components/

Returns a list of translation components in the given project.

Parameters:
  • project (string) – Project URL slug

Request JSON Object:
POST /api/projects/(string: project)/components/

Changed in version 4.3: The zipfile and docfile parameters are now accepted for VCS-less components, see Local files.

Changed in version 4.6: The cloned repositories are now automatically shared within a project using Weblate internal URLs. Use disable_autoshare to turn off this.

Creates translation components in the given project.

Hint

Use Weblate internal URLs when creating multiple components from a single VCS repository.

Note

Most of the component creation happens in the background. Check the task_url attribute of created component and follow the progress there.

Parameters:
  • project (string) – Project URL slug

Form Parameters:
  • file zipfile – ZIP file to upload into Weblate for translations initialization

  • file docfile – Document to translate

  • string from_component – Optional source component reference used to duplicate the new component. Accepts either a numeric component ID or a full Weblate component path. When provided, the new component inherits the source component configuration and translations into a new local repository. Repository fields such as repo, vcs, branch, push, and push_branch can not be combined with this option.

  • boolean disable_autoshare – Disables automatic repository sharing via Weblate internal URLs.

Response JSON Object:
Request JSON Object:

JSON can not be used when uploading the files using the zipfile and docfile parameters. The data has to be uploaded as multipart/form-data.

CURL form request example:

curl \
    --form docfile=@strings.html \
    --form name=Weblate \
    --form slug=weblate \
    --form file_format=html \
    --form new_lang=add \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/projects/hello/components/

CURL JSON request example:

curl \
    --data-binary '{
        "branch": "main",
        "file_format": "po",
        "file_format_params": {
            "po_line_wrap": 65535,
            "po_no_location": true
        },
        "filemask": "po/*.po",
        "name": "Weblate",
        "slug": "weblate",
        "repo": "https://github.com/WeblateOrg/hello.git",
        "template": "",
        "new_base": "po/hello.pot",
        "vcs": "git"
    }' \
    -H "Content-Type: application/json" \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/projects/hello/components/

JSON request to create a new component from Git:

POST /api/projects/hello/components/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{
    "branch": "main",
    "file_format": "po",
    "file_format_params": {
        "po_line_wrap": 65535,
        "po_no_location": true
    },
    "filemask": "po/*.po",
    "name": "Weblate",
    "slug": "weblate",
    "repo": "https://github.com/WeblateOrg/hello.git",
    "template": "",
    "new_base": "po/hello.pot",
    "vcs": "git"
}

JSON request to create a new component from another one:

POST /api/projects/hello/components/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{
    "from_component": "hello/weblate",
    "name": "Weblate",
    "slug": "weblate"
}

JSON response example:

HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{
    "branch": "main",
    "file_format": "po",
    "file_format_params": {
        "po_line_wrap": 65535,
        "po_no_location": true
    },
    "filemask": "po/*.po",
    "git_export": "",
    "license": "",
    "license_url": "",
    "name": "Weblate",
    "slug": "weblate",
    "project": {
        "name": "Hello",
        "slug": "hello",
        "source_language": {
            "code": "en",
            "direction": "ltr",
             "population": 159034349015,
            "name": "English",
            "url": "http://example.com/api/languages/en/",
            "web_url": "http://example.com/languages/en/"
        },
        "url": "http://example.com/api/projects/hello/",
        "web": "https://weblate.org/",
        "web_url": "http://example.com/projects/hello/"
    },
    "repo": "https://github.com/WeblateOrg/hello.git",
    "template": "",
    "new_base": "",
    "url": "http://example.com/api/components/hello/weblate/",
    "vcs": "git",
    "web_url": "http://example.com/projects/hello/weblate/"
}
GET /api/projects/(string: project)/languages/

Returns paginated statistics for all languages within a project.

Parameters:
  • project (string) – Project URL slug

Request JSON Object:
  • results (array) – array of translation statistics objects

  • language (string) – language name

  • code (string) – language code

  • total (int) – total number of strings

  • translated (int) – number of translated strings

  • translated_percent (float) – percentage of translated strings

  • total_words (int) – total number of words

  • translated_words (int) – number of translated words

  • words_percent (float) – percentage of translated words

GET /api/projects/(string: project)/statistics/

Returns statistics for a project.

Parameters:
  • project (string) – Project URL slug

See also

Returned attributes are described in Statistics.

GET /api/projects/(string: project)/metrics/

Added in version 2026.8.

Returns translation metrics for the project components visible to the caller. Components are identified by their project-relative path and the result is grouped by component and language. When multiple components have the same project-relative path, @ and the component ID are appended to each colliding path.

The OpenMetrics representation exposes weblate_translation_info and weblate_* gauges compatible with the project translation statistics. Strings containing suggestions use weblate_strings_with_suggestions to distinguish them from the server-wide weblate_suggestions object count. The CSV representation contains one row for each component, language, and numeric metric.

Parameters:
  • project (string) – Project URL slug

Query Parameters:
  • format (string) – Response format; use openmetrics or csv for monitoring and tabular output.

GET /api/projects/(string: project)/categories/

Added in version 5.0: Returns categories for a project. See GET /api/categories/(int:id)/ for field definitions.

param project:

Project URL slug

type project:

string

GET /api/projects/(string: project)/labels/

Added in version 5.3: Returns labels for a project.

param project:

Project URL slug

type project:

string

>json int id:

ID of the label

>json string name:

name of the label

>json string color:

color of the label

POST /api/projects/(string: project)/labels/

Added in version 5.3: Creates a label for a project. The label color is required.

param project:

Project URL slug

type project:

string

<json string name:

name of the label

<json string color:

color of the label

DELETE /api/projects/(string: project)/labels/(int: label_id)/

Added in version 5.14: Deletes a label from a project.

param project:

Project URL slug

type project:

string

param label_id:

ID of the label to delete

type label_id:

integer

GET /api/projects/(string: project)/saved-searches/

Added in version 2026.11: Returns saved searches for a project.

param project:

Project URL slug

type project:

string

>json int id:

ID of the saved search

>json string name:

name of the saved search

>json string query:

search query

>json string description:

description of the saved search

POST /api/projects/(string: project)/saved-searches/

Added in version 2026.11: Creates a saved search for a project.

param project:

Project URL slug

type project:

string

<json string name:

name of the saved search, unique within the project

<json string query:

search query

<json string description:

description of the saved search (optional)

DELETE /api/projects/(string: project)/saved-searches/(int: saved_search_id)/

Added in version 2026.11: Deletes a saved search from a project.

param project:

Project URL slug

type project:

string

param saved_search_id:

ID of the saved search to delete

type saved_search_id:

integer

GET /api/projects/(string: project)/reports/

Lists accessible reports generated directly for a project.

POST /api/projects/(string: project)/reports/

Schedules a report using the project as its scope. The request and response match POST /api/reports/; scope fields must be omitted.

GET /api/projects/(string: project)/translation-services/

Added in version 5.9.

Returns a list of translation service installations configured directly on the project. Each entry has an id, selector, engine, optional slug, configuration, enabled state, and scope fields. The configuration can contain credentials and is returned only to users who can edit the installation’s scope.

Parameters:
  • project (string) – Project URL slug

Request JSON Object:
  • installations (array) – Project installations.

POST /api/projects/(string: project)/translation-services/

Added in version 5.9.

Create a translation service installation for a project. Use /api/translation-services/(int:id)/ to update or remove one. The /api/translation-service-exclusions/ endpoint manages inherited installations excluded by a workspace or project. An installation’s service cannot be changed after creation; create another installation to use a different service. An exclusion’s scope and target cannot be changed after creation; remove it and create another exclusion to select a different target.

Parameters:
  • project (string) – Project URL slug

Form Parameters:
  • string engine – Service name

  • string slug – Optional installation slug

  • string configuration – Service configuration in JSON

GET /api/projects/(string: project)/machinery_settings/

Removed in version 2026.11: Use GET /api/projects/(string:project)/translation-services/ instead.

POST /api/projects/(string: project)/machinery_settings/

Removed in version 2026.11: Use POST /api/projects/(string:project)/translation-services/ instead.

GET /api/projects/(string: project)/languages/(string: language_code)/file/

Changed in version 5.15.1: Added ability to download ZIP file of all components translations in a project for 1 specific language.

Download a ZIP file of permitted translation files for a specified language_code across the components of a given project rather than downloading individual translated files and manually zipping them. The archive is named {project-slug}-{language-code}.zip and organized by component paths (e.g., component-slug/po/lang.po). Component restrictions and download permission are evaluated for each translation.

Parameters:
  • project (string) – Project URL slug

  • language_code (string) – Language code

Query Parameters:
  • filter (string) – Optional case-insensitive substring to filter components by slug (e.g., ?filter=core will match components with ‘core’ anywhere in their slug); only components whose slugs contain the substring will be included in the download.

  • format (string) – The archive format to use; If not specified, defaults to zip; Supported formats: zip and zip:CONVERSION where CONVERSION is one of converters listed at Downloading translations.

Note

Possible responses:

  • 200 OK with the permitted translations for the specified language. If no components have translations for the specified language, an empty ZIP file will be returned.

  • 403 Forbidden if matching translations exist but the user cannot download any of them.

  • 404 Not Found if the project slug or language code does not exist.

GET /api/projects/(string: project)/languages/(string: language_code)/announcements/

Added in version 2026.6: Returns announcements for a specified language_code in a project.

param project:

Project URL slug

type project:

string

param language_code:

Language code

type language_code:

string

>json int id:

ID of the announcement

>json string message:

announcement text

>json string severity:

color of the message, one of info (light blue), warning (yellow), danger (red), success (green)

>json date expiry:

hide after this date, ISO 8601 extended format date (optional)

>json bool notify:

send notification to subscribed users? (optional)

POST /api/projects/(string: project)/languages/(string: language_code)/announcements/

Added in version 2026.6: Creates an announcement for a specified language_code in a project.

param project:

Project URL slug

type project:

string

param language_code:

Language code

type language_code:

string

<json string message:

announcement text

<json string severity:

color of the message, one of info (light blue), warning (yellow), danger (red), success (green)

<json date expiry:

hide after this date, ISO 8601 extended format date (optional)

<json bool notify:

send notification to subscribed users? (optional)

DELETE /api/projects/(string: project)/languages/(string: language_code)/announcements/(int: announcement_id)/

Added in version 2026.6: Deletes an announcement from a specified language_code in a project.

param project:

Project URL slug

type project:

string

param language_code:

Language code

type language_code:

string

param announcement_id:

ID of the announcement to delete

type announcement_id:

integer

GET /api/projects/(string: project)/announcements/

Added in version 5.17: Returns announcements for a project.

param project:

Project URL slug

type project:

string

>json int id:

ID of the announcement

>json string message:

announcement text

>json string severity:

color of the message, one of info (light blue), warning (yellow), danger (red), success (green)

>json date expiry:

hide after this date, ISO 8601 extended format date (optional)

>json bool notify:

send notification to subscribed users? (optional)

POST /api/projects/(string: project)/announcements/

Added in version 5.17: Creates an announcement for a project.

param project:

Project URL slug

type project:

string

<json string message:

announcement text

<json string severity:

color of the message, one of info (light blue), warning (yellow), danger (red), success (green)

<json date expiry:

hide after this date, ISO 8601 extended format date (optional)

<json bool notify:

send notification to subscribed users? (optional)

DELETE /api/projects/(string: project)/announcements/(int: announcement_id)/

Added in version 5.17: Deletes an announcement from a project.

param project:

Project URL slug

type project:

string

param announcement_id:

ID of the announcement to delete

type announcement_id:

integer

GET /api/projects/(string: project)/backups/

Added in version 2026.7: Returns a list of Project level backups archives. Project backups contain all project components, including restricted components, and require Edit project settings.

param project:

Project URL slug

type project:

string

>json string name:

Backup file name, for example 1718803200.zip

>json string timestamp:

Backup creation time in ISO 8601 format

>json int size:

Backup file size in bytes

POST /api/projects/(string: project)/backups/

Added in version 2026.7: Schedules creation of a new Project level backups archive. Once ready, the backup appears in GET /api/projects/(string:project)/backups/.

param project:

Project URL slug

type project:

string

>json string detail:

Result message

>json string url:

URL to list backups

GET /api/projects/(string: project)/backups/(string: backup)/

Added in version 2026.7: Downloads a Project level backups archive containing all project components, including restricted components. This requires Edit project settings.

param project:

Project URL slug

type project:

string

param backup:

Backup file name, e.g. 1718803200.zip

type backup:

string

Components

Hint

Use POST /api/projects/(string:project)/components/ to create new components.

GET /api/components/

Returns a list of translation components.

See also

Component object attributes are documented at GET /api/components/(string:project)/(string:component)/.

GET /api/components/(string: project)/(string: component)/

Returns information about the translation component.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Request JSON Object:

Repository fields, including linked_component, are returned only with the View upstream repository location permission.

Example JSON data:

{
    "branch": "main",
    "file_format": "po",
    "file_format_params": {
        "po_line_wrap": 65535,
        "po_no_location": true
    },
    "filemask": "po/*.po",
    "git_export": "",
    "license": "",
    "license_url": "",
    "name": "Weblate",
    "slug": "weblate",
    "project": {
        "name": "Hello",
        "slug": "hello",
        "source_language": {
            "code": "en",
            "direction": "ltr",
             "population": 159034349015,
            "name": "English",
            "url": "http://example.com/api/languages/en/",
            "web_url": "http://example.com/languages/en/"
        },
        "url": "http://example.com/api/projects/hello/",
        "web": "https://weblate.org/",
        "web_url": "http://example.com/projects/hello/"
    },
    "source_language": {
        "code": "en",
        "direction": "ltr",
        "population": 159034349015,
        "name": "English",
        "url": "http://example.com/api/languages/en/",
        "web_url": "http://example.com/languages/en/"
    },
    "repo": "https://github.com/WeblateOrg/hello.git",
    "template": "",
    "new_base": "",
    "url": "http://example.com/api/components/hello/weblate/",
    "vcs": "git",
    "web_url": "http://example.com/projects/hello/weblate/"
}
PATCH /api/components/(string: project)/(string: component)/

Edit a component by a PATCH request.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • source_language (string) – Project source language code (optional)

Response JSON Object:

Linking to another Weblate component using an internal URL requires permission to edit the referenced component. Changing Restricted access follows the same direct component-access restrictions as the web interface.

CURL example:

curl \
    --data-binary '{"name": "new name"}' \
    -H "Content-Type: application/json" \
    -H "Authorization: Token TOKEN" \
    PATCH http://example.com/api/projects/hello/components/

JSON request example:

PATCH /api/projects/hello/components/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{
    "name": "new name"
}

JSON response example:

HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{
    "branch": "main",
    "file_format": "po",
    "file_format_params": {
        "po_line_wrap": 65535,
        "po_no_location": true
    },
    "filemask": "po/*.po",
    "git_export": "",
    "license": "",
    "license_url": "",
    "name": "new name",
    "slug": "weblate",
    "project": {
        "name": "Hello",
        "slug": "hello",
        "source_language": {
            "code": "en",
            "direction": "ltr",
            "population": 159034349015,
            "name": "English",
            "url": "http://example.com/api/languages/en/",
            "web_url": "http://example.com/languages/en/"
        },
        "url": "http://example.com/api/projects/hello/",
        "web": "https://weblate.org/",
        "web_url": "http://example.com/projects/hello/"
    },
    "repo": "https://github.com/WeblateOrg/hello.git",
    "template": "",
    "new_base": "",
    "url": "http://example.com/api/components/hello/weblate/",
    "vcs": "git",
    "web_url": "http://example.com/projects/hello/weblate/"
}
PUT /api/components/(string: project)/(string: component)/

Edit a component by a PUT request.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Response JSON Object:
  • branch (string) – VCS repository branch

  • file_format (string) – file format of translations

  • file_format_params (object) – parameters related to the file

  • filemask (string) – mask of translation files in the repository

  • name (string) – name of component

  • slug (string) – slug of component

  • repo (string) – VCS repository URL

  • template (string) – base file for monolingual translations

  • new_base (string) – base file for adding new translations

  • vcs (string) – version control system

  • vcs_params (object) – Version control parameters

  • hide_glossary_matches (boolean) – Do not show glossary matches

  • contribute_project_tm (boolean) – Contribute to project translation memory

DELETE /api/components/(string: project)/(string: component)/

Deletes a component.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

GET /api/components/(string: project)/(string: component)/changes/

Returns a list of component changes. This is essentially a component scoped GET /api/changes/ accepting same params.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Request JSON Object:
GET /api/components/(string: project)/(string: component)/file/

Added in version 4.9.

Downloads all available translations associated with the component as an archive file using the requested format.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Query Parameters:
  • format (string) – The archive format to use; If not specified, defaults to zip; Supported formats: zip and zip:CONVERSION where CONVERSION is one of converters listed at Downloading translations.

GET /api/components/(string: project)/(string: component)/screenshots/

Returns a list of component screenshots.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Request JSON Object:
GET /api/components/(string: project)/(string: component)/lock/

Returns component lock status.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Request JSON Object:
  • locked (boolean) – whether component is locked for updates

Example JSON data:

{
    "locked": false
}
POST /api/components/(string: project)/(string: component)/lock/

Sets component lock status.

Response is same as GET /api/components/(string:project)/(string:component)/lock/.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Response JSON Object:
  • lock – Boolean whether to lock or not.

CURL example:

curl \
    -d lock=true \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/components/hello/weblate/repository/

JSON request example:

POST /api/components/hello/weblate/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{"lock": true}

JSON response example:

HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{"locked":true}
GET /api/components/(string: project)/(string: component)/repository/

Returns information about the VCS repository status.

The response is same as for GET /api/projects/(string:project)/repository/.

Repository status requires component-wide permission on the component that owns the repository, including when accessing it through a linked component in another project.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Request JSON Object:
  • needs_commit (boolean) – whether there are any pending changes to commit

  • needs_merge (boolean) – whether there are any upstream changes to merge

  • needs_push (boolean) – whether there are any local changes to push

  • remote_commit (string) – Remote commit information

  • status (string) – VCS repository status as reported by VCS

  • merge_failure – Text describing merge failure or null if there is none

POST /api/components/(string: project)/(string: component)/repository/

Performs the given operation on a VCS repository.

See POST /api/projects/(string:project)/repository/ for documentation.

Repository operations require component-wide permission on the component that owns the repository, including when accessing it through a linked component in another project.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Response JSON Object:
  • operation (string) – Operation to perform: one of push, pull, commit, reset, cleanup

Request JSON Object:
  • result (boolean) – result of the operation

CURL example:

curl \
    -d operation=pull \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/components/hello/weblate/repository/

JSON request example:

POST /api/components/hello/weblate/repository/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{"operation":"pull"}

JSON response example:

HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{"result":true}
GET /api/components/(string: project)/(string: component)/monolingual_base/

Downloads base file for monolingual translations.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

GET /api/components/(string: project)/(string: component)/new_template/

Downloads template file for new translations.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

GET /api/components/(string: project)/(string: component)/translations/

Returns a list of translation objects in the given component.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Request JSON Object:
POST /api/components/(string: project)/(string: component)/translations/

Creates new translation in the given component.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Response JSON Object:
  • language_code (string) – translation language code; see GET /api/languages/(string:language)/

  • from_component (array) – optional ordered list of source component references used for automatic translation. Accepts numeric component IDs or full Weblate component paths. For form submissions this field can be provided multiple times.

Request JSON Object:
  • result (object) – new translation object created

CURL example:

curl \
    -d language_code=cs \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/projects/hello/components/

JSON request example:

POST /api/projects/hello/components/ HTTP/1.1
Host: example.com
Accept: application/json
Content-Type: application/json
Authorization: Token TOKEN
Content-Length: 20

{
    "language_code": "cs",
    "from_component": ["hello/weblate", 123]
}

JSON response example:

HTTP/1.0 200 OK
Date: Tue, 12 Apr 2016 09:32:50 GMT
Server: WSGIServer/0.1 Python/2.7.11+
Vary: Accept, Accept-Language, Cookie
X-Frame-Options: SAMEORIGIN
Content-Type: application/json
Content-Language: en
Allow: GET, POST, HEAD, OPTIONS

{
    "failing_checks": 0,
    "failing_checks_percent": 0,
    "failing_checks_words": 0,
    "filename": "po/cs.po",
    "fuzzy": 0,
    "fuzzy_percent": 0.0,
    "fuzzy_words": 0,
    "have_comment": 0,
    "have_suggestion": 0,
    "is_template": false,
    "is_source": false,
    "language": {
        "code": "cs",
        "direction": "ltr",
        "population": 1303174280
        "name": "Czech",
        "url": "http://example.com/api/languages/cs/",
        "web_url": "http://example.com/languages/cs/"
    },
    "language_code": "cs",
    "id": 125,
    "last_author": null,
    "last_change": null,
    "share_url": "http://example.com/engage/hello/cs/",
    "total": 4,
    "total_words": 15,
    "translate_url": "http://example.com/translate/hello/weblate/cs/",
    "translated": 0,
    "translated_percent": 0.0,
    "translated_words": 0,
    "url": "http://example.com/api/translations/hello/weblate/cs/",
    "web_url": "http://example.com/projects/hello/weblate/cs/"
}
GET /api/components/(string: project)/(string: component)/statistics/

Returns paginated statistics for all translations within component.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

See also

Returned attributes are described in Statistics.

Returns projects linked with a component.

Component managers see every linked project. Other callers see only linked projects they can access.

Added in version 4.5.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Request JSON Object:
POST /api/components/(string: project)/(string: component)/links/

Associate project with a component.

This requires permission to edit the component and the target project.

Added in version 4.5.

Changed in version 5.17.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

Form Parameters:
  • string project_slug – Project slug

  • int category_id – Category ID in the target project (optional). The category must belong to the specified project.

Remove association of a project with a component.

Added in version 4.5.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • project_slug (string) – Slug of the project to remove

GET /api/components/(string: project)/(string: component)/reports/

Lists accessible reports generated directly for a component.

POST /api/components/(string: project)/(string: component)/reports/

Schedules a report using the component as its scope. The request and response match POST /api/reports/; scope fields must be omitted.

GET /api/components/(string: project)/(string: component)/announcements/

Added in version 5.17: Returns announcements for a component.

param project:

Project URL slug

type project:

string

param component:

Component URL slug

type component:

string

>json int id:

ID of the announcement

>json string message:

announcement text

>json string severity:

color of the message, one of info (light blue), warning (yellow), danger (red), success (green)

>json date expiry:

hide after this date, ISO 8601 extended format date (optional)

>json bool notify:

send notification to subscribed users? (optional)

POST /api/components/(string: project)/(string: component)/announcements/

Added in version 5.17: Creates an announcement for a component.

param project:

Project URL slug

type project:

string

param component:

Component URL slug

type component:

string

<json string message:

announcement text

<json string severity:

color of the message, one of info (light blue), warning (yellow), danger (red), success (green)

<json date expiry:

hide after this date, ISO 8601 extended format date (optional)

<json bool notify:

send notification to subscribed users? (optional)

DELETE /api/components/(string: project)/(string: component)/announcements/(int: announcement_id)/

Added in version 5.17: Deletes an announcement from a component.

param project:

Project URL slug

type project:

string

param component:

Component URL slug

type component:

string

param announcement_id:

ID of the announcement to delete

type announcement_id:

integer

Translations

GET /api/translations/

Returns a list of translations.

See also

Translation object attributes are documented at GET /api/translations/(string:project)/(string:component)/(string:language)/.

GET /api/translations/(string: project)/(string: component)/(string: language)/

Returns information about the translation.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

Request JSON Object:

Example JSON data:

{
    "component": {
        "branch": "main",
        "file_format": "po",
        "file_format_params": {
            "po_line_wrap": 65535,
            "po_no_location": true
        },
        "filemask": "po/*.po",
        "git_export": "",
        "license": "",
        "license_url": "",
        "name": "Weblate",
        "new_base": "",
        "project": {
            "name": "Hello",
            "slug": "hello",
            "source_language": {
                "code": "en",
                "direction": "ltr",
                "population": 159034349015,
                "name": "English",
                "url": "http://example.com/api/languages/en/",
                "web_url": "http://example.com/languages/en/"
            },
            "url": "http://example.com/api/projects/hello/",
            "web": "https://weblate.org/",
            "web_url": "http://example.com/projects/hello/"
        },
        "repo": "https://github.com/WeblateOrg/hello.git",
        "slug": "weblate",
        "template": "",
        "url": "http://example.com/api/components/hello/weblate/",
        "vcs": "git",
        "web_url": "http://example.com/projects/hello/weblate/"
    },
    "failing_checks": 3,
    "failing_checks_percent": 75.0,
    "failing_checks_words": 11,
    "filename": "po/cs.po",
    "fuzzy": 0,
    "fuzzy_percent": 0.0,
    "fuzzy_words": 0,
    "have_comment": 0,
    "have_suggestion": 0,
    "is_template": false,
    "language": {
        "code": "cs",
        "direction": "ltr",
        "population": 1303174280
        "name": "Czech",
        "url": "http://example.com/api/languages/cs/",
        "web_url": "http://example.com/languages/cs/"
    },
    "language_code": "cs",
    "last_author": "Weblate Admin",
    "last_change": "2016-03-07T10:20:05.499",
    "revision": "7ddfafe6daaf57fc8654cc852ea6be212b015792",
    "share_url": "http://example.com/engage/hello/cs/",
    "total": 4,
    "total_words": 15,
    "translate_url": "http://example.com/translate/hello/weblate/cs/",
    "translated": 4,
    "translated_percent": 100.0,
    "translated_words": 15,
    "url": "http://example.com/api/translations/hello/weblate/cs/",
    "web_url": "http://example.com/projects/hello/weblate/cs/"
}
DELETE /api/translations/(string: project)/(string: component)/(string: language)/

Deletes a translation.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

GET /api/translations/(string: project)/(string: component)/(string: language)/changes/

Returns a list of translation changes. This is essentially a translations-scoped GET /api/changes/ accepting the same parameters.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

Request JSON Object:
GET /api/translations/(string: project)/(string: component)/(string: language)/units/

Returns a list of translation units.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

  • q (string) – Search query string Searching (optional)

Request JSON Object:
POST /api/translations/(string: project)/(string: component)/(string: language)/units/

Add new unit.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

Response JSON Object:
  • key (string) – Monolingual translations: Key of translation unit

  • value (array) – Monolingual translations: Source strings (use single string if not creating plural)

  • context (string) – Bilingual translations: Context of a translation unit

  • source (array) – Bilingual translations: Source strings (use single string if not creating plural)

  • target (array) – Bilingual translations: Target strings (use single string if not creating plural)

  • state (int) – String state; see GET /api/units/(int:id)/

Request JSON Object:

Creating a unit in the approved state requires permission to review strings.

POST /api/translations/(string: project)/(string: component)/(string: language)/autotranslate/

Changed in version 5.13: The filter_type parameter is no longer supported and filtering is done by the q parameter.

Changed in version 2026.10: Added the background parameter.

Trigger automatic translation.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

Response JSON Object:
  • mode (string) – Automatic translation mode; one of suggest, translate, fuzzy, approved

  • q (string) – Automatic translation search string, see Searching for strings.

  • auto_source (string) – Automatic translation source - mt or others

  • component (string) – Component ID (always accepted); when the project has 30 or more eligible source components, a component slug or project/component path is also accepted; leave blank to use all components in the project

  • engines (array) – Translation services to use when auto_source is mt

  • threshold (int) – Score threshold for machine translation (1–100)

  • background (boolean) – Schedule automatic translation as a background task instead of waiting for it to finish. Defaults to false.

Request JSON Object:
  • details (string) – Human-readable summary of the translation result, or status of a background task

  • errors (array) – Errors encountered during automatic translation; an empty array when completed without errors. Omitted while a background task is queued.

  • task_url (string) – URL for tracking a background task; see GET /api/tasks/(str:uuid)/

With background set to true, the endpoint returns 202 Accepted once the task is scheduled. Validation and permission errors are still reported immediately.

Completed requests return 200 OK, including when some or all translation service batches fail. Successful translations are retained. Check errors to distinguish provider failures from a run with nothing to update. Error details follow the diagnostic permissions described in Tasks; other readers receive a generic error explanation.

GET /api/translations/(string: project)/(string: component)/(string: language)/file/

Download current translation file as it is stored in the VCS (without the format parameter) or converted to another format (see Downloading translations).

Note

This API endpoint uses different logic for output than rest of API as it operates on whole file rather than on data. Set of accepted format parameter differs and without such parameter you get translation file as stored in VCS.

Response Headers:
Request Headers:
  • If-Modified-Since – Skips response if the file has not been modified since that time.

Query Parameters:
  • format – File format to use; if not specified no format conversion happens; see Downloading translations for supported formats

  • q (string) – Filter downloaded strings, see Search Page, only applicable when conversion is in place (format is specified).

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

POST /api/translations/(string: project)/(string: component)/(string: language)/file/

Upload new file with translations.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

Form Parameters:
  • boolean ignore_language – Ignore a mismatch between the declared file language and the translation language (defaults to false), see Language checking

  • string conflicts – How to deal with conflicts (ignore, replace-translated or replace-approved), see Conflicts handling

  • file file – Uploaded file or file content sent as a form field without a filename

  • string author_email – Author e-mail

  • string author_name – Author name

  • string method – Upload method (translate, approve, suggest, fuzzy, replace, source, add), see Import methods

  • string fuzzy – Fuzzy (marked for edit) strings processing (empty, process, approve)

CURL example:

curl -X POST \
    -F file=@strings.xml \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/translations/hello/android/cs/file/

The file field can also be sent as form content without a filename, for example when piping data from another command:

curl -X POST \
    -F 'file=<strings.xml' \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/translations/hello/android/cs/file/

The content is used as submitted, byte for byte, so any file encoding works.

GET /api/translations/(string: project)/(string: component)/(string: language)/repository/

Returns information about the VCS repository status.

The response is same as for GET /api/components/(string:project)/(string:component)/repository/.

Repository status requires component-wide permission on the component that owns the repository, including when accessing it through a linked component in another project. A permission limited to the requested language is not sufficient.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

POST /api/translations/(string: project)/(string: component)/(string: language)/repository/

Performs given operation on the VCS repository.

See POST /api/projects/(string:project)/repository/ for documentation.

Repository operations require component-wide permission on the component that owns the repository, including when accessing it through a linked component in another project. A permission limited to the requested language is not sufficient.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

Response JSON Object:
  • operation (string) – Operation to perform: one of push, pull, commit, reset, cleanup

Request JSON Object:
  • result (boolean) – result of the operation

GET /api/translations/(string: project)/(string: component)/(string: language)/statistics/

Returns detailed translation statistics.

Parameters:
  • project (string) – Project URL slug

  • component (string) – Component URL slug

  • language (string) – Translation language code

See also

Returned attributes are described in Statistics.

GET /api/translations/(string: project)/(string: component)/(string: language)/announcements/

Added in version 5.17: Returns announcements for a translation.

param project:

Project URL slug

type project:

string

param component:

Component URL slug

type component:

string

param language:

Translation language code

type language:

string

>json int id:

ID of the announcement

>json string message:

announcement text

>json string severity:

color of the message, one of info (light blue), warning (yellow), danger (red), success (green)

>json date expiry:

hide after this date, ISO 8601 extended format date (optional)

>json bool notify:

send notification to subscribed users? (optional)

POST /api/translations/(string: project)/(string: component)/(string: language)/announcements/

Added in version 5.17: Creates an announcement for a translation.

param project:

Project URL slug

type project:

string

param component:

Component URL slug

type component:

string

param language:

Translation language code

type language:

string

<json string message:

announcement text

<json string severity:

color of the message, one of info (light blue), warning (yellow), danger (red), success (green)

<json date expiry:

hide after this date, ISO 8601 extended format date (optional)

<json bool notify:

send notification to subscribed users? (optional)

DELETE /api/translations/(string: project)/(string: component)/(string: language)/announcements/(int: announcement_id)/

Added in version 5.17: Deletes an announcement from a translation.

param project:

Project URL slug

type project:

string

param component:

Component URL slug

type component:

string

param language:

Translation language code

type language:

string

param announcement_id:

ID of the announcement to delete

type announcement_id:

integer

Memory

Added in version 4.14.

GET /api/memory/

Returns a paginated list of memory results visible to the authenticated user. When no source filter is supplied, the response enumerates all visible entries, including the global shared translation memory. Shared entries contain their source string, translation, and project and component origin. Project access control does not restrict entries explicitly published to shared translation memory; see Shared translation memory.

Query Parameters:
  • source – Case-insensitive substring filter on source text (optional)

  • source_language – Source language code filter (optional)

  • target_language – Target language code filter (optional)

  • project – Project slug filter (optional)

POST /api/memory/lookup/

Looks up translation memory matches for the provided source strings.

Query Parameters:
  • source_language – Source language code

  • target_language – Target language code

  • project – Project slug filter (optional)

  • exact – Return exact matches only and skip fuzzy matching (optional)

Response JSON Object:
  • strings (array) – List of source strings to look up

Request JSON Object:
  • results (array) – Ordered lookup results with the best match for each query or null when no match was found

DELETE /api/memory/(int: memory_object_id)/

Deletes a memory object

Parameters:
  • memory_object_id – Memory Object ID

Units

A unit is a single piece of a translation which pairs a source string with a corresponding translated string and also contains some related metadata. The term is derived from the translate.storage.base.TranslationUnit in Translate Toolkit and XLIFF.

GET /api/units/

Returns a list of translation units.

Parameters:
  • q (string) – Search query string Searching (optional)

See also

Unit object attributes are documented at GET /api/units/(int:id)/.

GET /api/units/(int: id)/

Changed in version 4.3: The target and source are now arrays to properly handle plural strings.

Changed in version 5.6: The last_updated attribute is now exposed.

Changed in version 2026.10: The screenshots_url attribute is now exposed.

Returns information about the translation unit.

Parameters:
  • id (int) – Unit ID

Request JSON Object:
  • translation (string) – URL of a related translation object

  • source (array) – source string

  • previous_source (string) – previous source string used for fuzzy matching

  • target (array) – target string

  • id_hash (string) – unique identifier of the unit

  • content_hash (string) – unique identifier of the source string

  • location (string) – location of the unit in source code

  • context (string) – translation unit context

  • note (string) – translation unit note

  • flags (string) – translation unit flags

  • labels (array) – translation unit labels, available on source units

  • state (int) – unit state, 0 - untranslated, 10 - needs editing, 20 - translated, 30 - approved, 100 - read-only

  • fuzzy (boolean) – whether the unit is fuzzy or marked for review

  • translated (boolean) – whether the unit is translated

  • approved (boolean) – whether the translation is approved

  • position (int) – unit position in translation file

  • has_suggestion (boolean) – whether the unit has suggestions

  • has_comment (boolean) – whether the unit has comments

  • has_failing_check (boolean) – whether the unit has failing checks

  • num_words (int) – number of source words

  • priority (int) – translation priority; 100 is default

  • id (int) – unit identifier

  • tbx_terms (object) – Read-only TBX metadata with source and target alternative lists. Each record contains text, optional ID, administrative status, and notes with text, origin, category, and scope (concept, language, or term). Empty for other formats.

  • explanation (string) – String explanation, available on source units, see Additional info on source strings

  • extra_flags (string) – Additional flags for this unit; source flags apply to all languages and translation flags apply only to that language, see Translation flags

  • web_url (string) – URL where the unit can be edited

  • source_unit (string) – Source unit link; see GET /api/units/(int:id)/

  • screenshots_url (string) – URL to list and manage associated screenshots; see GET /api/units/(int:id)/screenshots/

  • translation_parent (string) – Read-only link to the configured parent unit, or null when using the component source or the configured parent is missing; see Custom source language

  • effective_source (array) – Read-only source text used for translation, including plural forms. The existing source field continues to contain the canonical file source.

  • effective_previous_source (array) – Read-only previous source text shown before an effective-source change, including plural forms. The existing previous_source field retains the canonical file-source value.

  • effective_source_language (string) – Read-only language code of the effective source, retaining the configured language when its source is missing

  • pending (boolean) – whether the unit is pending for write

  • timestamp (timestamp) – string age

  • last_updated (timestamp) – last string update

PATCH /api/units/(int: id)/

Added in version 4.3.

Performs partial update on translation unit.

Parameters:
  • id (int) – Unit ID

Response JSON Object:
  • state (int) – unit state, 0 - untranslated, 10 - needs editing, 20 - translated, 30 - approved (need review workflow enabled, see Dedicated reviewers)

  • target (array) – target string

  • explanation (string) – String explanation, available on source units, see Additional info on source strings

  • extra_flags (string) – Additional flags for this unit; source flags apply to all languages and translation flags apply only to that language, see Translation flags

  • labels (array) – labels, available on source units

PUT /api/units/(int: id)/

Added in version 4.3.

Performs full update on translation unit.

Parameters:
  • id (int) – Unit ID

Response JSON Object:
  • state (int) – unit state, 0 - untranslated, 10 - needs editing, 20 - translated, 30 - approved (need review workflow enabled, see Dedicated reviewers)

  • target (array) – target string

  • explanation (string) – String explanation, available on source units, see Additional info on source strings

  • extra_flags (string) – Additional flags for this unit; source flags apply to all languages and translation flags apply only to that language, see Translation flags

  • labels (array) – labels, available on source units

POST /api/units/(int: id)/source/

Edit the source string associated with a unit, updating its existing translations within the component. Requires source-editing permission and Manage strings. See Editing source strings and keys for format support and restrictions.

Parameters:
  • id (int) – unit ID in any language

Response JSON Object:
  • content_hash (integer) – current content hash of the source unit, required to detect stale edits

  • source (array) – replacement source forms, preserving the existing number of forms; optional

  • context (string) – replacement key or context; optional

  • explanation (string) – source explanation; optional

Request JSON Object:
Status Codes:
  • 200 OK – source updated, or the request made no changes

  • 400 Bad Request – invalid edit, conflicting key, unsupported operation, or stale content hash

  • 403 Forbidden – editing is not permitted

  • 423 Locked – component is busy; retry later

Omitted fields remain unchanged. Translation text and associated history are retained. Source-text changes mark translations as needing editing; key-only changes preserve translation states. Files are updated by the normal pending-change queue, respecting the project’s commit policy.

DELETE /api/units/(int: id)/

Added in version 4.3.

Deletes a translation unit.

Parameters:
  • id (int) – Unit ID

GET /api/units/(int: id)/translations/

Added in version 5.11.

Returns a list of all target translation units for the given source translation unit.

GET /api/units/(int: id)/screenshots/

Added in version 2026.10.

Returns a paginated list of screenshots associated with the unit.

Parameters:
  • id (int) – Unit ID

See also

Screenshot object attributes are documented at GET /api/screenshots/(int:id)/.

POST /api/units/(int: id)/screenshots/

Added in version 2026.10.

Associate screenshot with unit.

Parameters:
  • id (int) – Unit ID

Form Parameters:
  • string screenshot_id – Screenshot ID; the screenshot must belong to the same component and language as the unit

See also

Returns the associated screenshot; see GET /api/screenshots/(int:id)/.

DELETE /api/units/(int: id)/screenshots/(int: screenshot_id)

Added in version 2026.10.

Remove screenshot association with unit.

Parameters:
  • id (int) – Unit ID

  • screenshot_id (int) – Screenshot ID

POST /api/units/(int: id)/comments/

Added in version 5.12.

Create a new comment on the given translation unit.

Parameters:
  • id (int) – Unit ID

Response JSON Object:
  • scope (string) – comment scope - global, translation (available on all non-source units), report (need review workflow enabled, see Dedicated reviewers)

  • comment (string) – content of the new comment, you can use Markdown and mention users by @username.

  • user_email (string) – commenter’s email, can be set only by project admins and defaults to the authenticated user.

  • timestamp (string) – creation timestamp of the comment, can be set only by project admins and defaults to now.

Request JSON Object:
  • id (int) – comment identifier

  • comment (string) – content of the new comment

  • user (string) – URL of the commenter’s object

  • timestamp (string) – creation timestamp of the comment

GET /api/units/(int: id)/comments/

Added in version 5.15.

Returns a list of comments on a given translation unit

Parameters:
  • id (int) – Unit ID

Request JSON Object:
  • id (int) – comment identifier

  • comment (string) – content of the comment

  • timestamp (string) – creation timestamp of the comment

  • user (string) – URL of the commenter’s object

POST /api/units/(int: id)/suggestions/

Added in version 2026.8.

Create a new suggestion on the given translation unit.

Requires authentication and the Add suggestion permission on the translation. Suggestions must be enabled on the translation, the translation must not be read-only, and the user must have signed any required contributor agreement.

Parameters:
  • id (int) – Unit ID

Response JSON Object:
  • target (array) – suggested translation text as a list of plural forms; use a single-element array for non-plural strings

Request JSON Object:
  • id (int) – suggestion identifier

  • target (array) – suggested translation text as a list of plural forms

  • unit (string) – URL of the related unit object

  • user (string) – URL of the suggester’s object

  • timestamp (string) – creation timestamp of the suggestion

  • votes (int) – net vote count for the suggestion

Users who also have the Vote on suggestion permission automatically upvote their suggestion when it is created.

When the same suggestion already exists from another user and the caller has the Vote on suggestion permission, the existing suggestion is upvoted instead and the response uses the same format as POST /api/suggestions/(int:id)/vote/ (HTTP status 200 instead of 201).

GET /api/units/(int: id)/suggestions/

Added in version 2026.8.

Returns a paginated list of suggestions on a given translation unit.

Parameters:
  • id (int) – Unit ID

Request JSON Object:

Suggestions

GET /api/suggestions/

Added in version 2026.8.

Returns a paginated list of suggestions the user has access to, ordered by creation time (most recent first).

See also

Suggestion object attributes are documented at GET /api/suggestions/(int:id)/.

Request JSON Object:
GET /api/suggestions/(int: id)/

Added in version 2026.8.

Returns information about a suggestion.

Parameters:
  • id (int) – Suggestion ID

Request JSON Object:
  • id (int) – suggestion identifier

  • target (array) – suggested translation text as a list of plural forms

  • unit (string) – URL of the related unit object

  • user (string) – URL of the suggester’s object, or null for anonymous suggestions

  • timestamp (string) – creation timestamp of the suggestion

  • votes (int) – net vote count for the suggestion

DELETE /api/suggestions/(int: id)/

Added in version 2026.8.

Delete or reject a suggestion.

Requires the Delete suggestion permission on the related translation, or ownership of the suggestion.

Parameters:
  • id (int) – Suggestion ID

Response JSON Object:
  • rejection_reason (string) – optional reason for rejecting the suggestion

  • is_spam (boolean) – whether to report the suggestion as spam

The request body is optional. When is_spam is true, the suggestion content is reported to the antispam service.

POST /api/suggestions/(int: id)/accept/

Added in version 2026.8.

Accept a suggestion and apply it to the translation unit.

Requires the Accept suggestion permission on the related translation unit.

Parameters:
  • id (int) – Suggestion ID

Response JSON Object:
  • approve (boolean) – whether to mark the translation as approved after accepting; requires the Review strings permission and review workflow enabled (see Dedicated reviewers)

Request JSON Object:
  • result (string) – accepted when the suggestion was accepted

POST /api/suggestions/(int: id)/vote/

Added in version 2026.8.

Vote for or against a suggestion.

Requires the Vote on suggestion permission and voting enabled on the related translation (see Suggestion voting).

Parameters:
  • id (int) – Suggestion ID

Response JSON Object:
  • value (int) – 1 to vote for the suggestion or -1 to vote against it

Request JSON Object:
  • result (string) – voted when the suggestion remains open; accepted when auto-accept applied it

  • suggestion (object) – updated suggestion object when result is voted; null when result is accepted

Changes

GET /api/changes/

Changed in version 4.1: Filtering of changes was introduced in the 4.1 release.

Returns a list of translation changes.

See also

Change object attributes are documented at GET /api/changes/(int:id)/.

Query Parameters:
  • user (string) – Username of the user to filter by

  • action (int) – Action to filter, can be used several times; see Selected change events for available values

  • timestamp_after (timestamp) – ISO 8601 formatted timestamp to list changes after

  • timestamp_before (timestamp) – ISO 8601 formatted timestamp to list changes before

GET /api/changes/(int: id)/

Returns information about the translation change.

Parameters:
  • id (int) – Change ID

Request JSON Object:
  • unit (string) – URL of a related unit object

  • translation (string) – URL of a related translation object

  • component (string) – URL of a related component object

  • user (string) – URL of a related user object

  • author (string) – URL of a related author object

  • timestamp (timestamp) – event timestamp

  • action (int) – numeric identification of action

  • action_name (string) – text description of action

  • target (string) – event changed text

  • old (string) – previous text

  • details (object) – additional details about the change

  • id (int) – change identifier

When an IP address is recorded for an anonymous change, the ip_address attribute in details is included only for superusers.

New changes include a change_origin object in details, for example {"change_origin": {"scope": "api"}}. The scope is ui for browser sessions, including session-authenticated API requests, or api for successful Token or Bearer authentication. Repository string imports use repository, including imports triggered through the UI or API. Uploads retain their UI or API origin. Changes without request or inherited background-task attribution use system. Background tasks inherit their initiating origin.

Changes made by automation use the automation scope and identify both the installed add-on and its execution log, for example {"change_origin": {"scope": "automation", "automation": {"addon_id": 12, "activity_id": 34}}}. This attribution also applies to background work and repository processing initiated by the automation. The identifiers remain in change history after the add-on or execution log is deleted. Workflow settings are not included.

Historical changes can omit change_origin. The separate origin field on component creation events describes how the component was created. Clients should allow additional scopes and origin attributes. Token credentials are never included.

Screenshots

GET /api/screenshots/

Returns a list of screenshots.

See also

Screenshot object attributes are documented at GET /api/screenshots/(int:id)/.

GET /api/screenshots/(int: id)/

Returns information about the screenshot.

Parameters:
  • id (int) – Screenshot ID

Request JSON Object:
  • name (string) – name of a screenshot

  • repository_filename (string) – repository path used to match repository-based screenshot updates

  • translation (string) – URL of a related translation object

  • file_url (string) – URL to download a file; see GET /api/screenshots/(int:id)/file/

  • units (array) – link to associated source string information; see GET /api/units/(int:id)/

GET /api/screenshots/(int: id)/file/

Download the screenshot image.

Parameters:
  • id (int) – Screenshot ID

POST /api/screenshots/(int: id)/file/

Replace screenshot image.

Parameters:
  • id (int) – Screenshot ID

Form Parameters:
  • file image – Uploaded file

CURL example:

curl -X POST \
    -F image=@image.png \
    -H "Authorization: Token TOKEN" \
    http://example.com/api/screenshots/1/file/
POST /api/screenshots/(int: id)/units/

Associate source string with screenshot.

Parameters:
[...]
